#include <iostream>
#include <stdlib.h>
#include <vector>
#include <type_traits>

using namespace std;


template<class T>
bool checkConst(T &t)
{
   return is_const<T>::value;
}

template<class T>
bool checkConst(T *t)
{
   return is_const<T>::value;
}



int main(int argc, char **argv)
{
    
    const int bob = 0;
    int       bill= 0;

    vector<int *>        ipv;
    vector<int const *>  cipv;

    ipv.push_back(&bill);
    cipv.push_back(&bill);

    cout << "checkConst(const int bob) = " << checkConst(bob) << endl;
    cout << "checkConst(int bill     ) = " << checkConst(bill) << endl;

    cout << endl;

    cout << "checkConst(&(const int bob)) = " << checkConst(&bob) << endl;
    cout << "checkConst(&(int bill     )) = " << checkConst(&bill) << endl;

    cout << endl;
    cout << "checkConst(*vector<int*>.begin()      ) = " << checkConst(*ipv.begin()) << endl;
    cout << "checkConst(*vector<const int*>.begin()) = " << checkConst(*cipv.begin()) << endl;

    cout << "checkConst(vector<int*>[0]      ) = " << checkConst(ipv[0]) << endl;
    cout << "checkConst(vector<const int*>[0]) = " << checkConst(cipv[0]) << endl;

    cout << endl;

    const vector<int*> *cpipv = &ipv;

    cout << "checkConst(cpipv) = " << checkConst(cpipv) << endl;
    cout << "checkConst((*cpipv)[0]) = " << checkConst((*cpipv)[0]) << endl;

    *(*cpipv)[0] = 9;   



}
